int __real_main(int, char **);

cl_int __real_clGetPlatformIDs(cl_uint, cl_platform_id *, cl_uint *);/*0x01*/

cl_int __real_clGetPlatformInfo(cl_platform_id, cl_platform_info, size_t, void *, size_t *);/*0x02*/

cl_int __real_clGetDeviceIDs(cl_platform_id, cl_device_type, cl_uint, cl_device_id *, cl_uint *);/*0x03*/

cl_int __real_clGetDeviceInfo(cl_device_id, cl_device_info, size_t, void *, size_t *);/*0x04*/

cl_context __real_clCreateContext(const cl_context_properties *, cl_uint, const cl_device_id *, void (CL_CALLBACK *)(const char *, const void *, size_t, void *), void *, cl_int *);/*0x05*/

cl_context __real_clCreateContextFromType(const cl_context_properties *, cl_device_type, void (CL_CALLBACK *)(const char *, const void *, size_t, void *), void *, cl_int *);/*0x06*/

cl_int __real_clRetainContext(cl_context);/*0x07*/

cl_int __real_clReleaseContext(cl_context);/*0x08*/

cl_int __real_clGetContextInfo(cl_context, cl_context_info, size_t, void *, size_t *);/*0x09*/

cl_command_queue __real_clCreateCommandQueue(cl_context, cl_device_id, cl_command_queue_properties, cl_int *);/*0x0A*/

cl_int __real_clRetainCommandQueue(cl_command_queue);/*0x0B*/

cl_int __real_clReleaseCommandQueue(cl_command_queue);/*0x0C*/

cl_int __real_clGetCommandQueueInfo(cl_command_queue, cl_command_queue_info, size_t, void *, size_t *);/*0x0D*/

cl_mem __real_clCreateBuffer(cl_context, cl_mem_flags, size_t, void *, cl_int *);/*0x0E*/

cl_mem __real_clCreateSubBuffer(cl_mem, cl_mem_flags, cl_buffer_create_type, const void *, cl_int *);/*0x0F*/

cl_int __real_clEnqueueReadBuffer(cl_command_queue, cl_mem, cl_bool, size_t, size_t, void *, cl_uint, const cl_event *, cl_event *);/*0x10*/

cl_int __real_clEnqueueWriteBuffer(cl_command_queue, cl_mem, cl_bool, size_t, size_t, const void *, cl_uint, const cl_event *, cl_event *);/*0x11*/

//0x16: void * clEnqueueMapBuffer (cl_command_queue command_queue, cl_mem buffer, cl_bool blocking_map, cl_map_flags map_flags, size_t offset, size_t cb, cl_uint num_events_in_wait_list, const cl_event *event_wait_list, cl_event *event, cl_int *errcode_ret)

cl_int __real_clRetainMemObject(cl_mem);/*0x21*/

cl_int __real_clReleaseMemObject(cl_mem);/*0x22*/

//0x23: cl_int clSetMemObjectDestructorCallback (cl_mem memobj, void (CL_CALLBACK *pfn_notify)(cl_mem memobj, void *user_data), void *user_data)

//0x24: cl_int clEnqueueUnmapMemObject (cl_command_queue command_queue, cl_mem memobj, void *mapped_ptr, cl_uint num_events_in_wait_list, const cl_event *event_wait_list, cl_event *event)

cl_int __real_clGetMemObjectInfo(cl_mem, cl_mem_info, size_t, void *, size_t *);/*0x25*/

cl_program __real_clCreateProgramWithSource(cl_context, cl_uint, const char **, const size_t *, cl_int *);/*0x29*/

cl_int __real_clRetainProgram(cl_program);/*0x2B*/

cl_int __real_clReleaseProgram(cl_program);/*0x2C*/

cl_int __real_clBuildProgram(cl_program, cl_uint, const cl_device_id *, const char *, void (CL_CALLBACK *)(cl_program, void *), void *);/*0x2D*/

cl_int __real_clGetProgramInfo(cl_program, cl_program_info, size_t, void *, size_t *);/*0x2F*/

cl_int __real_clGetProgramBuildInfo(cl_program, cl_device_id, cl_program_build_info, size_t, void *, size_t *);/*0x30*/

cl_kernel __real_clCreateKernel(cl_program, const char *, cl_int *);/*0x31*/

cl_int __real_clCreateKernelsInProgram(cl_program, cl_uint, cl_kernel *, cl_uint *);/*0x32*/

cl_int __real_clRetainKernel(cl_kernel);/*0x33*/

cl_int __real_clReleaseKernel(cl_kernel);/*0x34*/

cl_int __real_clSetKernelArg(cl_kernel, cl_uint, size_t, const void *);/*0x35*/

cl_int __real_clGetKernelInfo(cl_kernel, cl_kernel_info, size_t, void *, size_t *);/*0x36*/

cl_int __real_clGetKernelWorkGroupInfo(cl_kernel, cl_device_id, cl_kernel_work_group_info, size_t, void *, size_t *);/*0x37*/

cl_int __real_clEnqueueNDRangeKernel(cl_command_queue, cl_kernel, cl_uint, const size_t *, const size_t *, const size_t *, cl_uint, const cl_event *, cl_event *);/*0x38*/

cl_event __real_clCreateUserEvent(cl_context, cl_int *);/*0x3B*/

cl_int __real_clSetUserEventStatus(cl_event, cl_int);/*0x3C*/

cl_int __real_clWaitForEvents(cl_uint, const cl_event *);/*0x3D*/

cl_int __real_clGetEventInfo(cl_event, cl_event_info, size_t, void *, size_t *);/*0x3E*/

//0x3F: cl_int clSetEventCallback (cl_event event, cl_int command_exec_callback_type, void (CL_CALLBACK *pfn_event_notify)(cl_event event, cl_int event_command_exec_status, void *user_data), void *user_data)

cl_int __real_clRetainEvent(cl_event);/*0x40*/

cl_int __real_clReleaseEvent(cl_event);/*0x41*/

//0x42: cl_int clEnqueueMarker (cl_command_queue command_queue, cl_event *event)

//0x43: cl_int clEnqueueBarrier (cl_command_queue command_queue)

//0x44: cl_int clEnqueueWaitForEvents (cl_command_queue command_queue, cl_uint num_events, const cl_event *event_list)

cl_int __real_clFlush(cl_command_queue);/*0x46*/

cl_int __real_clFinish(cl_command_queue);/*0x47*/

cl_int __real_clGetEventProfilingInfo(cl_event, cl_profiling_info, size_t, void *, size_t *);/*0x48*/
