#!/usr/bin/python
# -*- coding: utf8 -*-

import commands, sys


def omx_hosts():
	hosts =[]
	(status, output) = commands.getstatusoutput('/opt/open-mx/bin/omx_info')
	if status == 0:
		start = 0
		for line in output.splitlines():
			if start == 1:
				hosts.append((line.split()[1], line.split()[2].split(':')[0]))
			elif line == '================================================':
				start = 1
	return hosts


def omx_find_endpoints(host, executable):
	endpoints = []
	(status, output) = commands.getstatusoutput('ssh %s /opt/open-mx/bin/omx_endpoint_info'%(host))
	#(status, output) = commands.getstatusoutput('/opt/open-mx/bin/omx_endpoint_info')
	if status == 0:
		start = 0
		for line in output.splitlines():
			if start == 1:
				if line.split()[5] == '(%s)'%(executable):
					endpoints.append(line.split()[0])
			elif line == '==============================================':
				start = 1
	return endpoints


host_list = omx_hosts()
for (addr, host) in host_list:
	endpoint_list = omx_find_endpoints(host, 'ccl_daemon')
	for endpoint in endpoint_list:
		print '0x%s; %s'%(addr.replace(':', ''), endpoint)
